program othello;

uses crt, graph, mouse;

const
(*
  chemin = 'c:\tp6\bgi';
*)
  chemin = 'c:\prog\tp7\bgi';

const
  pi = 3.1415926535;               { aide - mmoire :
              Que j'aime  faire apprendre ce nombre utile aux sages
               3 ,1   4  1   5       9      2    6     5    3    5  }

type
  TypeOthellier = array[0..9, 0..9] of integer;

const
  dx : array [1..8] of integer =
       (0, 1, 1, 1, 0, -1, -1, -1);
  dy : array [1..8] of integer =
       (-1, -1, 0, 1, 1, 1, 0, -1);

const
  OthellierOriginal : TypeOthellier =
      ((   0,   0,   0,   0,   0,   0,   0,   0,   0,   0),
       (   0, -99,  -1, -15, -15, -15, -15,  -1, -99,   0),
       (   0,  -1,  -1,  -5,  -5,  -5,  -5,  -1,  -1,   0),
       (   0, -15,  -5,  -5,  -5,  -5,  -5,  -5, -15,   0),
       (   0, -15,  -5,  -5,   1,   2,  -5,  -5, -15,   0),
       (   0, -15,  -5,  -5,   2,   1,  -5,  -5, -15,   0),
       (   0, -15,  -5,  -5,  -5,  -5,  -5,  -5, -15,   0),
       (   0,  -1,  -1,  -5,  -5,  -5,  -5,  -1,  -1,   0),
       (   0, -99,  -1, -15, -15, -15, -15,  -1, -99,   0),
       (   0,   0,   0,   0,   0,   0,   0,   0,   0,   0));

   OthellierPresentation : TypeOthellier =
      (( 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
       ( 0,-99,-1,-15,-15,-15,-15,-1,-99, 0),
       ( 0,-1,-1,-5,-5,-5,-5,-1,-1, 0),
       ( 0, 2, 2,-5, 2, 1, 2,-5,-15, 0),
       ( 0, 2, 2, 2, 1, 1, 1,-5,-15, 0),
       ( 0, 2, 2, 2, 1, 1,-5,-5,-15, 0),
       ( 0, 2,-5, 1, 2, 1,-5,-5,-15, 0),
       ( 0,-1,-1,-5, 1,-5,-5,-1,-1, 0),
       ( 0,-99,-1, 1, 1, 1,-15,-1,-99, 0),
       ( 0, 0, 0, 0, 0, 0, 0, 0, 0, 0));


var
  Othellier : TypeOthellier;
  Commande : integer;
  Code : char;
  Jeu, Fin : boolean;

const
  CouleurBord = 14;
  LongueurCase = 50;
  LargeurTour = 30;
  CouleurCase = 8;
  CouleurTourCase = Black;
  OrigineAbscisse = 0;
  OrigineOrdonnee = 0;
  Longueur = 8 * LongueurCase + 2 * LargeurTour;
  RayonPion = 20;

type
  coup = record
           x : integer;
           y : integer;
         end;

var
  j : integer;
  c : coup;
  n : integer;
  nc : integer;
  p : boolean;

var
  dir : array [1..8] of boolean;

const
  JeuHumain = 0;
  JeuOrdinateur = 1;
  TypeJoueur : array [1..2] of integer = (JeuHumain, JeuOrdinateur);

procedure init;
  const
    graphpilote : integer = 9;
    graphmode : integer = 0;

  begin
    initgraph (graphmode, graphpilote, chemin);
  end;

procedure Souris_au_repos;
  begin
    repeat
    until mouse_bouton = 0;
  end;

procedure DessineOthellier;
  var
    x, y : integer;
    i : integer;

  procedure DefinirCouleursTour;
    var
      i : integer;

    begin
      for i := 1 to 4 do
        SetRGBPalette (i, 38 + i * 5, 0, 25 - i * 5);
    end;

  begin
    DefinirCouleursTour;
    for i := 0 to 3 do
      begin
        SetFillStyle (1, i + 1);
        Bar (OrigineAbscisse+7*i, OrigineOrdonnee+7*i,
             OrigineAbscisse + Longueur - 7*i,
             OrigineOrdonnee + Longueur - 7*i);
      end;
    SetFillStyle (1, 0);
    Bar (0, 0, 29, 29);
    Bar (431, 0, 460, 29);
    Bar (0, 431, 29, 460);
    Bar (431, 431, 460, 460);
    For i := 0 to 3 do
      begin
        SetColor (i + 1);
        SetFillStyle (1, i+1);
        PieSlice (30, 30, 90, 180, 30-i*7);
        PieSlice (430, 30, 0, 90, 30-i*7);
        PieSlice (30, 430, 180, 270, 30-i*7);
        PieSlice (430, 430, 270, 360, 30-i*7);
      end;
    SetFillStyle (1, CouleurCase);
    SetLineStyle (0, 0, 0);
    SetColor (0);
    for y := 0 to 7 do
      for x := 0 to 7 do
        begin
          bar (origineabscisse + largeurtour + x * longueurcase,
               origineordonnee + largeurtour + y * longueurcase,
               origineabscisse + largeurtour + (x + 1) * longueurcase,
               origineordonnee + largeurtour + (y + 1) * longueurcase);
          rectangle (origineabscisse + largeurtour + x * longueurcase,
                     origineordonnee + largeurtour + y * longueurcase,
                     origineabscisse + largeurtour + (x + 1) * longueurcase,
                     origineordonnee + largeurtour + (y + 1) * longueurcase);
        end;

  (* marquer les coordoones *)
  settextstyle (0, horizdir, 2);
  settextjustify (1, 1);
  for x := 0 to 7 do
    begin
      outtextxy (LargeurTour + x * LongueurCase + LongueurCase div 2,
                 Longueur - LargeurTour div 2,
                 chr (65 + x));
      outtextxy (LargeurTour div 2,
                 Longueur - (LargeurTour + x * LongueurCase + LongueurCase div 2),
                 chr (49 + x));
    end;
  end;

procedure pion (x, y, c : integer);
  begin
    SetColor (0);
    SetLineStyle (0, 0, 1);
    SetFillStyle (1, (c - 1) * 15);
    PieSlice (LargeurTour + (x-1) * LongueurCase + LongueurCase div 2,
              LargeurTour + (8-y) * LongueurCase + LongueurCase div 2,
              0, 360, RayonPion);
    SetColor ((c-1) * 15);
    Line (LargeurTour + (x-1) * LongueurCase + LongueurCase div 2
          + RayonPion - 1,
          LargeurTour + (8-y) * LongueurCase + LongueurCase div 2,
          LargeurTour + (x-1) * LongueurCase + LongueurCase div 2,
          LargeurTour + (8-y) * LongueurCase + LongueurCase div 2);
  end;

procedure CasePointee (x, y : integer ; var c : coup);
{ dtermine la case pointe par la souris }
   var
     rx, ry : integer;

   begin
     rx := x - LargeurTour;
     ry := y - LargeurTour;
     if (rx < 0) or (ry < 0) or
       (rx > 8 * LongueurCase) or (ry > 8 * LongueurCase)
     then
       begin
         c.x := 0;
         c.y := 0;
       end
     else
       begin
         c.x := round (int (rx / LongueurCase) + 1);
         c.y := round (int (8 - (ry / LongueurCase) + 1));
       end;
  end;

procedure PlacePions;
  var
    x, y : integer;

  begin
    for y := 1 to 8 do
      for x := 1 to 8 do
        if Othellier[x, y] > 0 then
          pion (x, y, Othellier[x, y]);
  end;

procedure Page_de_presentation;
  var
    i, j : integer;

  begin
    Othellier := OthellierPresentation;
    DessineOthellier;
    PlacePions;
    SetPalette (8, 43);
    for i := 1 to 6 do
      begin
        setpalette (8+i, 8+i);
        setrgbpalette (8+i, 5*i+30, 5 * i+30, 0);
      end;
    SetTextStyle (1, 0, 10);
    SetTextJustify (1, 1);
    for i := 0 to 3 do
      for j := 0 to 2 do
            begin
              setcolor (0);
              outtextxy (340 + i*3 + j , 180 + i*3 + j, 'Othello');
              outtextxy (340 + i*3 + j + 1 , 180 + i*3 + j, 'Othello');
            end;
    for i := 1 to 6 do
      for j := 0 to 2 do
        begin
            begin
              setcolor (8+i);
              outtextxy (320 + i*3 + j , 160 + i*3 + j, 'Othello');
              outtextxy (320 + i*3 + j + 1 , 160 + i*3 + j, 'Othello');
            end;
        end;
    settextstyle (1, 0, 6);
    settextjustify (0, 2);
    for i := 1 to 7 do
      begin
        setcolor (0);
          for j := 0 to 2 do
            begin
              outtextxy (4+i+j, 324+i, 'Pressez une touche');
              outtextxy (4+i+j, 364+i, 'pour commencer');
            end;
          end;
    for i := 1 to 6 do
      begin
        setcolor (8+i);
          for j := 0 to 2 do
            begin
              outtextxy (i+j, 320+i, 'Pressez une touche');
              outtextxy (i+j, 360+i, 'pour commencer');
            end;
          end;
  end;

procedure menu;
  var
    i, j, b : integer;

  procedure fixecouleursmenu;
    var
      i : integer;

    begin
      for i := 0 to 2 do
        begin
          SetPalette (11 + i, 11 + i);
          SetRGBPalette (11 + i, 63,0, i * 20);
        end;
      for i := 0 to 7 do
        begin
          SetPalette (1 + i, 1 + i);
          SetRGBPalette (1 + i, 2 * i + 2, 2 * i + 20, 5 * i + 28);
        end;
      setpalette (15, 63);
    end;

  procedure Humain (x, y : integer);
    var
      i : integer;

    begin
      for i := 0 to 7 do
        begin
          setcolor (1 + i);
          setfillstyle (1, 1 + i);
          bar (x + 10, y + 62 + i, x + 70, y + 78 - i);
        end;
      for i := 0 to 7 do
        begin
          setcolor (1 + i);
          setfillstyle (1, 1 + i);
          line (x + 32 + i, y + 100, x + 20 + i, y + 140);
          line (x + 47 - i, y + 100, x + 35 - i, y + 140);
        end;
      for i := 0 to 7 do
        begin
          setcolor (1 + i);
          setfillstyle (1, 1 + i);
          line (x + 33 + i, y + 100, x + 45 + i, y + 140);
          line (x + 48 - i, y + 100, x + 60 - i, y + 140);
        end;
      for i := 0 to 7 do
        begin
          setcolor (1 + i);
          setfillstyle (1, 1 + i);
          bar (x + 32 + i , y + 40, x + 48 - i, y + 100);
        end;
      for i := 0 to 7 do
        begin
          setcolor (1 + i);
          setfillstyle (1, 1 + i);
          pieslice (x + 40, y + 40, 0, 360, 2 + (7-i) * 2);
        end;
      end;

  procedure ordinateur (x, y : integer);
    var
      i : integer;

    begin
      for i := 0 to 7 do
        begin
          setcolor (i + 1);
          setfillstyle (1, i+1);
          line (x + 10 + i, y + 30 + i, x + 10 + i, y + 80 - i);
          line (x + 10 + i, y + 30 + i, x + 70 - i, y + 30 + i);
          line (x + 70 - i, y + 30 + i, x + 70 - i, y + 80 - i);
          line (x + 10 + i, y + 80 - i, x + 70 - i, y + 80 - i);
          line (x + 20 - i * 2, y + 100 + i * 4,
                x + 60 + i * 2, y + 100 + i * 4);
          line (x + 20 - i * 2, y + 101 + i * 4,
                x + 60 + i * 2, y + 101 + i * 4);
          line (x + 19 - i * 2, y + 102 + i * 4,
                x + 61 + i * 2, y + 102 + i * 4);
          line (x + 19 - i * 2, y + 103 + i * 4,
                x + 61 + i * 2, y + 103 + i * 4);
        end;
    end;

  procedure cadre (i, j : integer);
    var
      k : integer;

    begin
      for k := 0 to 2 do
        begin
          setcolor (11 + k);
          rectangle (160 + 240*i + k, 60+(j-1)*200+k,
                     240 + 240*i - k, 200+(j-1)*200 - k);
        end;
    end;

  function dans (i, a, b : integer) : boolean;
    begin
      if (a <= i) and (i <= b)
      then
        dans := true
      else
        dans := false;
    end;

  procedure affichemenu;
    var
      i, j : integer;

    begin
      setfillstyle (1, 0);
      bar (0, 0, 639, 479);
      settextstyle (1, 0, 7);
      settextjustify (1, 1);
      for j := 0 to 1 do
        begin
          for i := 0 to 2 do
            begin
              setcolor (11 + i);
              outtextxy (320 + i, 200*j+24, 'JOUEUR '+chr(49+j));
              humain (160, 50 + 200*j);
              ordinateur (400, 50 + 200*j);
              Cadre (TypeJoueur[j+1], j+1);
            end;
        end;
      for i := 0 to 2 do
        begin
          setcolor (11 + i);
          outtextxy (200 + i, 440, 'JEU');
          outtextxy (440 + i, 440, 'FIN');
        end;
    end;

  begin
    fixecouleursmenu;
    jeu := false;
    fin := false;
    repeat
      cache;
      affichemenu;
      curseur;
      repeat
        b := mouse_bouton;
      until (b = 1);
    i := mouse_x;
    j := mouse_y;
    if dans (i, 160, 240) and dans(j, 60, 200)
    then
      TypeJoueur[1] := 0;
    if dans (i, 400, 480) and dans (j, 60, 200)
    then
      TypeJoueur[1] := 1;
    if dans (i, 160, 240) and dans (j, 260, 400)
    then
      TypeJoueur[2] := 0;
    if dans (i, 400, 480) and dans (j, 260, 400)
    then
      TypeJoueur[2] := 1;
    if dans (i, 150, 250) and dans(j, 420, 480)
    then
      Jeu := true;
    if dans (i, 390, 490) and dans(j, 420, 480)
    then
      Fin := true;
    until Jeu or Fin;
  cache;
  end;


procedure beep;
  begin
    sound (100);
    delay (200);
    sound (32000);
    delay (200);
    nosound;
  end;

procedure OK;
  begin
    sound (1000);
    delay (100);
    sound (32000);
    delay (500);
    nosound;
  end;

procedure Erreur;
  var
    i : integer;

  begin
    for i := 1 to 3 do
      begin
        sound (500);
        delay (100);
        sound (32000);
        delay (200);
      end;
    nosound;
  end;

function ComptePions (j : integer ; c : coup) : integer;
  var
    p : coup;
    d : integer;
    nc, np : integer;

  begin
    nc := 0;
    for d := 1 to 8 do
      begin
        p := c;
        np := 0;
        repeat
          p.x := p.x + dx[d];
          p.y := p.y + dy[d];
          inc (np);
        until othellier[p.x, p.y] <> (3 - j);
        dec(np);
        if othellier[p.x, p.y] = j
        then
          begin
            nc := nc + np;
            dir [d] := true;
          end
        else
          dir [d] := false;
      end;
    ComptePions := nc;
    end;

function Valide (j : integer ; c : coup) : boolean;
  begin
    if (ComptePions (j, c) = 0) or (Othellier[c.x, c.y] >= 0)
    then
      valide := false
    else
      valide := true;
  end;

procedure Impossible;
  var
    i : integer;

  begin
    SetTextStyle (1, 0, 3);
    for i := 0 to 2 do
      begin
        SetColor (11 + i);
        OutTextXY (480 + i, 400, 'IMPOSSIBLE');
      end;
    Erreur;
    Delay (3000);
  end;

function NombreLibertes (j : integer) : integer;
  var
    c : coup;
    n : integer;

  begin
    n := 0;
    for c.y := 1 to 8 do
      for c.x := 1 to 8 do
        if valide (j, c)
        then
          inc (n);
    NombreLibertes := n;
  end;

function NombrePions (j : integer) : integer;
  var
    c : coup;
    n : integer;

  begin
    n := 0;
    for c.y := 1 to 8 do
      for c.x := 1 to 8 do
        begin
          if othellier [c.x, c.y] = j
          then
            inc (n);
        end;
  NombrePions := n;
  end;

function passe (j : integer) : boolean;
  var
    x, y : integer;
    c : coup;

    p : boolean;

  begin
    p := true;
    for c.y := 1 to 8 do
      for c.x := 1 to 8 do
        begin
          if valide (j, c)
          then
            p := false;
        end;
    passe := p;
  end;

procedure EcrirePasse;
  var
    i : integer;

  begin
    SetTextStyle (1, 0, 5);
    for i := 0 to 2 do
      begin
        setcolor (11 + i);
        OutTextXY (480 + i, 400, 'PASSE');
      end;
    Erreur;
    Delay (3000);
  end;

procedure AfficheInfos;
  const
    yj : array [1..2] of integer = (525, 595);

  var
    n : integer;
    s : string;
    j : integer;
    i : integer;

  procedure pion (x, y, c : integer);
  const
    rayonpion = 8;

  begin
    SetColor (15);
    SetLineStyle (0, 0, 1);
    SetFillStyle (1, (c - 1) * 15);
    PieSlice (x, y, 0, 360, RayonPion);
    SetColor ((c-1) * 15);
    Line (x, y, x + rayonpion - 1, y);
  end;

  begin
    SetTextStyle (1, 0, 4);
    SetTextJustify (0, 2);
    for i := 0 to 2 do
      begin
        SetColor (11 + i);
        OutTextXY (480 + i, 230, 'PIONS');
        OutTextXY (480 + i, 310, 'LIBERTES');
      end;
    SetTextStyle (1, 0, 4);
    SetTextJustify (1, 2);
    for j := 1 to 2 do
      begin
        pion (yj[j], 275, j);
        n := NombrePions (j);
        str (n, s);
        for i := 0 to 2 do
          begin
            SetColor (5 + i);
            OutTextXY (yj[j] + i, 280, s);
          end;
        pion (yj[j], 355, j);
        n := NombreLibertes (j);
        str (n, s);
        for i := 0 to 2 do
          begin
            SetColor (5 + i);
            OutTextXY (yj[j] + i, 360, s);
          end;
     end;
  end;

const
  Ajoute = 1;
  Enleve = 2;

procedure CasesJouables (j : integer ; ordre : integer);
  var
    c : coup;

  begin
    for c.y := 1 to 8 do
      for c.x := 1 to 8 do
        if valide(j,c)
        then
          case ordre of
             Ajoute : begin

             SetLineStyle (0, 0, 3);
             SetColor (0);

             line (origineabscisse + largeurtour + (c.x-1)*longueurcase + 10,
               origineordonnee + largeurtour + (8-c.y)*longueurcase + 10,
               origineabscisse + largeurtour + (c.x) * longueurcase - 10,
               origineordonnee + largeurtour + (9-c.y) * longueurcase - 10);
             line (origineabscisse + largeurtour + (c.x)*longueurcase - 10,
               origineordonnee + largeurtour + (8-c.y)*longueurcase + 10,
               origineabscisse + largeurtour + (c.x-1) * longueurcase + 10,
               origineordonnee + largeurtour + (9-c.y) * longueurcase - 10);


                      end;

             Enleve : begin

             SetFillStyle (1, CouleurCase);
             SetLineStyle (0, 0, 1);
             SetColor (0);

             bar (origineabscisse + largeurtour + (c.x-1) * longueurcase,
               origineordonnee + largeurtour + (8-c.y) * longueurcase,
               origineabscisse + largeurtour + (c.x) * longueurcase,
               origineordonnee + largeurtour + (9-c.y) * longueurcase);
             rectangle (origineabscisse + largeurtour + (c.x-1) * longueurcase,
               origineordonnee + largeurtour + (8-c.y) * longueurcase,
               origineabscisse + largeurtour + (c.x) * longueurcase,
               origineordonnee + largeurtour + (9-c.y) * longueurcase);

                      end;
          end;
  end;

function confirmation : boolean;
  var
    i : integer;
    car : char;

  begin
    settextstyle (1, 0, 6);
    settextjustify (0, 2);
    for i := 0 to 2 do
      begin
        setcolor (5 + i);
        outtextxy (480 + i, 200, 'VOUS');
        outtextxy (480 + i, 250, 'ETES');
        outtextxy (480 + i, 300, 'SUR ?');
      end;
    repeat
      car := readkey;
      car := upcase(car);
      beep;
    until car in ['O', 'N'];
    if car = 'O'
    then
      confirmation := true
    else
      confirmation := false;
  end;

procedure EntrerCode;
  var
    i : integer;

  begin
    settextstyle (1, 0, 6);
    settextjustify (0, 2);
    for i := 0 to 2 do
      begin
        setcolor (5 + i);
        outtextxy (480 + i, 250, 'CODE?');
      end;
    repeat
      code := readkey;
      code := upcase(code);
      beep;
    until code in ['0'..'9', 'A'..'Z', #27];
    if code = #27
    then
      commande := 0;
  end;

procedure SauvePartie;
  var
    car : char;
    fic : file of integer;
    i, j : integer;

  begin
    car := code;
    assign (fic, 'PARTIE-' + car + '.OTH');
    rewrite (fic);
    write (fic, j);
    for i := 1 to 2 do
      write (fic, TypeJoueur[i]);
    for j := 0 to 9 do
      for i := 0 to 9 do
        write (fic, othellier[i, j]);
    close (fic);
  end;

function FileExists(FileName: String): Boolean;
{ Boolean function that returns True if the file exists;otherwise,
 it returns False. Closes the file if it exists. }
var
F: file;
begin
 {$I-}
 Assign(F, FileName);
 FileMode := 0;  { Set file access to read only }
 Reset(F);
 Close(F);
 {$I+}
 FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }

procedure ChargePartie;
  var
    car : char;
    fic : file of integer;
    i, j : integer;

  begin
    car := code;
    if fileexists ( 'PARTIE-' + car + '.OTH')
    then
      begin
        assign (fic, 'PARTIE-' + car + '.OTH');
        reset (fic);
        read (fic, j);
        for i := 1 to 2 do
          read (fic, TypeJoueur[i]);
        for j := 0 to 9 do
          for i := 0 to 9 do
            read (fic, othellier[i, j]);
        close (fic);
      end
    else
      begin
        j := 1;
        Othellier := OthellierOriginal;
      end;
  end;

procedure Affiche_menu_cote;
  type
    option = array[0..1] of string;

  const
    liste_option : array [1..5] of option =
      (('NOUVELLE','PARTIE'),
       ('CHARGER','PARTIE'),
       ('SAUVER','PARTIE'),
       ('RETOUR','AU MENU'),
       ('RETOUR','AU JEU'));

  procedure affiche_options;
    var
      i, k, l : integer;

    begin
      cache;
      SetFillStyle (1,0);
      Bar (480, 0, 639, 479);
      SetTextStyle (1, 0, 4);
      for i := 1 to 5 do
        for k := 0 to 1 do
          for l := 0 to 2 do
            begin
              SetColor (11 + l);
              OutTextXY (480 + l, 30 + 30*k + 80*(i-1), liste_option[i,k]);
            end;
    end;

  function Position_souris : integer;
    var
      x, y : integer;
      n : integer;

    begin
      x := mouse_x;
      y := mouse_y;
      if (x<480) or (y<30)
      then
        n := 0
      else
        begin
          y := y - 30;
          if (y mod 80) > 60
          then
            n := 0
          else
            begin
              n := (y div 80) + 1;
              if n>5
              then
                n := 0;
            end;
        end;
    Position_souris := n;
    end;

  function Selection : integer;
    var
      n, b : integer;
      car : char;

    begin
      repeat
        curseur;
        repeat
          b := mouse_bouton;
        until (b = 1) or keypressed;
        cache;
        if b = 1
        then
          n := Position_souris
        else
          begin
            car := readkey;
            n := ord(car) - 64;
          end;
      until n in [1..5];
      selection := n;
    end;

  procedure affiche_titre_option (n : integer);
    var
      k, l : integer;

    begin
      SetFillStyle (1,0);
      Bar (480, 0, 639, 479);
      SetTextStyle (1, 0, 4);
        for k := 0 to 1 do
          for l := 0 to 2 do
            begin
              SetColor (11 + l);
              OutTextXY (480 + l, 30 + 30*k, liste_option[n,k]);
            end;
    end;

  begin
    Affiche_options;
    commande := selection;
    if commande = 5
    then
      commande := 0;
    affiche_titre_option (commande);
    if (commande = 1) or (commande = 4)
    then
      if confirmation = false
      then
        commande := 0;
    if (commande = 2) or (commande = 3)
    then
      EntrerCode;
  end;

procedure EntrerCoup (j : integer ; var c : coup);
  var
    car : char;
    i : integer;
    n : integer;
    x, y : integer;
    b : integer;          (* boutons enfoncs *)
    cs : coup;            (* coup dsign par la souris *)

  label 1;

  begin
    commande := 0;
  1:CasesJouables (j, Ajoute);
    if commande <> 0
    then
      exit;
    repeat
      SetFillStyle (0, 0);
      Bar (480, 0, 639, 479);
      AfficheInfos;
      SetTextStyle (1, 0, 5);
      SetTextJustify (0, 2);
      For i := 0 to 2 do
        begin
          setcolor (11 + i);
          OutTextXY (480 + i, 0, 'JOUEUR');
        end;
      SetColor (12);
      SetTextStyle (1, 0, 7);
      if j = 1
      then
        for i := 0 to 2 do
          begin
            setcolor (5 + i);
            OutTextXY (540 + i, 30, '1');
          end
      else
        for i := 0 to 2 do
          begin
            setcolor (5 + i);
            OutTextXY (540 + i, 30, '2');
          end;
      SetTextStyle (1, 0, 5);
      for i := 0 to 2 do
        begin
          SetColor (11 + i);
          OutTextXY (480 + i, 100 , 'VOTRE');
          OutTextXY (480 + i, 140 , 'COUP');
        end;
      repeat
        curseur;
        repeat
          b := mouse_bouton;
          if (b = 2)
          then
            begin
              Affiche_menu_cote;
              goto 1;
            end;
        until (b = 1) or keypressed;
        cache;
        if b = 1
        then
          begin
            CasePointee (Mouse_X, Mouse_Y, cs);
            car := chr (cs.x + 64);
          end
        else
          car := readkey;
        car := UpCase (car);
        beep;
      until car in ['A'..'H'];
      c.x := ord (car) - 64;
      SetTextStyle (1, 0, 7);
      for i := 0 to 2 do
        begin
          SetColor (5 + i);
          OutTextXY (480 + i, 170, car);
        end;
      repeat
        repeat
        until (b = 1) or keypressed;
        if b = 1
        then
          car := chr (cs.y + 48)
        else
          car := readkey;
        beep;
      until car in ['1'..'8'];
      c.y := ord (car) - 48;
      for i := 0 to 2 do
        begin
          SetColor (5 + i);
          OutTextXY (528 + i, 170, car);
        end;
      n := ComptePions (j, c);
      if (n = 0) or (Othellier[c.x, c.y] >= 0)
      then
        Impossible;

    until (n<>0) and (Othellier[c.x, c.y] < 0);
    CasesJouables (j, Enleve);
    n := ComptePions (j, c);
    OK;
  end;

procedure AfficheCoup (j : integer ; c : coup);
  var
    i : longint;
    b : integer;
    car : char;

label 1;

  begin
    commande := 0;
 1: SetFillStyle (0, 0);
    Bar (480, 0, 639, 479);
    AfficheInfos;
    if commande <> 0
    then
      exit;
    SetTextStyle (1, 0, 5);
    SetTextJustify (0, 2);
      For i := 0 to 2 do
        begin
          setcolor (11 + i);
          OutTextXY (480 + i, 0, 'JOUEUR');
        end;
      SetColor (12);
      SetTextStyle (1, 0, 7);
      if j = 1
      then
        for i := 0 to 2 do
          begin
            setcolor (5 + i);
            OutTextXY (540 + i, 30, '1');
          end
      else
        for i := 0 to 2 do
          begin
            setcolor (5 + i);
            OutTextXY (540 + i, 30, '2');
          end;
      SetTextStyle (1, 0, 5);
      for i := 0 to 2 do
        begin
          SetColor (11 + i);
          OutTextXY (480 + i, 100 , 'MON');
          OutTextXY (480 + i, 140 , 'COUP');
        end;
      car := chr (c.x + 64);
      SetTextStyle (1, 0, 7);
      for i := 0 to 2 do
        begin
          SetColor (5 + i);
          OutTextXY (480 + i, 170, car);
        end;
      car := chr (c.y + 48);
      for i := 0 to 2 do
        begin
          SetColor (5 + i);
          OutTextXY (528 + i, 170, car);
        end;
    OK;
    i := 0;
    repeat
      inc (i);
      b := mouse_bouton;
      if b = 2
        then
          begin
            curseur;
            affiche_menu_cote;
            goto 1;
          end;
    until keypressed or (i = 10000) or (b = 1);
    if keypressed
    then
      car := readkey;
  end;



procedure RetournePions (j : integer ; c : coup);
  var
    d : integer;
    p : coup;

  begin
    for d := 1 to 8 do
      if dir[d] = true
      then
        begin
          p := c;
          repeat
            Othellier[p.x, p.y] := j;
            p.x := p.x + dx[d];
            p.y := p.y + dy[d];
          until Othellier[p.x, p.y] <> (3 - j);
        end;
  end;

procedure Maximisation (j : integer ; var co : coup);
  var
    c : coup;
    cmax : coup;
    othtemp : TypeOthellier;
    n : integer;
    nmax : integer;
    x, y : integer;

  begin
    nmax := -1;
    for c.x := 1 to 8 do
      for c.y := 1 to 8 do
        begin
          OthTemp := Othellier;
          if valide (j, c)
          then
            begin
              RetournePions (j, c);
              n := NombrePions (j);
            end
          else
            n := -1;
          if n > nmax
          then
            begin
              nmax := n;
              cmax := c;
            end;
          Othellier := OthTemp;
        end;
    co := cmax;
    n := ComptePions (j, co);
  end;

procedure MaxLibertes (j : integer ; var co : coup);
  var
    c : coup;
    cmax : coup;
    othtemp : TypeOthellier;
    n : integer;
    nmax : integer;
    x, y : integer;

  begin
    nmax := -1;
    for c.x := 1 to 8 do
      for c.y := 1 to 8 do
        begin
          OthTemp := Othellier;
          if valide (j, c)
          then
            begin
              RetournePions (j, c);
              n := NombreLibertes (j);
            end
          else
            n := -1;
          if n > nmax
          then
            begin
              nmax := n;
              cmax := c;
            end;
          Othellier := OthTemp;
        end;
    co := cmax;
    n := ComptePions (j, co);
  end;

procedure MeilleureCase (j : integer ; var co : coup);
  var
    c, cmax : coup;
    n : integer;

  begin
    n := 0;
    for c.x := 1 to 8 do
      for c.y := 1 to 8 do
        if valide (j, c)
        then
          if -Othellier[c.x, c.y] > n
          then
            begin
              n := -Othellier[c.x, c.y];
              cmax := c;
            end;
    co := cmax;
    n := ComptePions (j, co);
  end;

var
  no : integer;   (* numro d'option du menu *)
  i, b : integer;
  car : char;

label 1, 2, 3;

begin
  init;
  mouse_reset;
  Page_de_presentation;
  repeat
    b := mouse_bouton;
  until (b = 1) or keypressed;
  if keypressed
  then
    car := readkey;
1:curseur;
  menu;
  Souris_au_repos;
  while jeu do
  begin
2:init;
  Othellier := OthellierOriginal;
  SetPalette (8, 43);
  SetPalette (12, 15);
  SetPalette (14, 53);
  for i := 0 to 2 do
    begin
      SetPalette (11 + i, 11 + i);
      SetRGBPalette (11 + i, 63,0, i * 20);
      SetPalette (5 + i, 5 + i);
      SetRGBPalette (5 + i, 5 * i + 10, 5 * i + 30, 10 * i + 40);
    end;
  DessineOthellier;
  PlacePions;
  j := 1;
  repeat
   3: if not passe (j)
      then
        begin
          if TypeJoueur[j] = JeuHumain
          then
            begin
              EntrerCoup (j, c);
              RetournePions (j, c);
              PlacePions;
            end
          else
            begin
              MeilleureCase (j, c);
              RetournePions (j, c);
              PlacePions;
              AfficheCoup (j, c);
            end;
        end
      else
        EcrirePasse;
      case commande of
        1 : goto 2;
        2 : begin
              ChargePartie;
              DessineOthellier;
              PlacePions;
            end;
        3 : SauvePartie;
        4 : goto 1;
      end;
      if (commande = 2) or (commande = 3)
      then
        goto 3;
      j := 3 - j;
  until (passe (1)) and (passe (2));
  SetFillStyle (1, 0);
  Bar (480, 0, 639, 479);
  AfficheInfos;
  repeat
    b := mouse_bouton;
  until (b = 1) or keypressed;
  if keypressed
  then
    car := readkey;
  curseur;
  menu;
  Souris_au_repos;
  end;
closegraph;
TextMode (co80);
end.
